module Main where

-- MITSFS iPhone schedule pretty-printer
-- Copyright (C) 2008 Brian Sniffen

-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License along
-- with this program; if not, write to the Free Software Foundation, Inc.,
-- 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


import Data.Maybe (fromJust)
import System.Environment

import Model
import GetURL
import Parser
import Printer

usage progName = "usage: " ++ progName ++ " [URL or file ...]\n" ++
                 "       " ++ progName ++ " # defaults to " ++ defaultURL
                           ++ "\n"

main :: IO ()
main = do
  args <- getArgs
  if args == ["--help"]
   then do
     progName <- getProgName
     putStr $ usage progName
   else do
     r <- case args of
            [] -> readFrom defaultURL
            filenames -> 
                      mapM readFrom filenames >>= return . concat
     putStr $ htmlify $ schedule r



  
